#version 330

layout(points) in;								// We get points as input
layout(triangle_strip, max_vertices = 4) out;	// We want to draw rectangles

in float type0[];
out vec2 tex_uv;

uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;
uniform mat4 modelMatrix;

uniform vec3 cameraPosition;

#define SIZE (0.2)


void main()
{
	if(type0[0] == 1) {
		EndPrimitive();
	} else {
		vec3 pos = gl_in[0].gl_Position.xyz;

		// Rotate particles to camera
		vec3 camera = normalize(cameraPosition - pos);
		vec3 up = vec3(0,1,0);
		vec3 right = cross(camera, up);

		// left bottom
		pos -= right * SIZE;
		gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(pos,1);
		tex_uv = vec2(0,0);
		EmitVertex();

		// left top
		pos.y += SIZE;
		gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(pos, 1.0);
		tex_uv = vec2(0,1);
		EmitVertex();

		pos.y -= SIZE;
		pos += right * SIZE;
		gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(pos, 1.0);
		tex_uv = vec2(1,0);
		EmitVertex();

		pos.y += SIZE;
		gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(pos, 1.0);
		tex_uv = vec2(1,1);
		EmitVertex();

		EndPrimitive();
	}
}
