#version 330

layout(points) in;						// We get points as input
layout(points, max_vertices=1) out;     // and send points as output

in float type0[];
in vec3 position0[];
in float age0[];
in float velocity0[];
in float lifetime0[];
in vec3 flydirection0[];

out float type1;
out vec3 position1;
out float age1;
out float velocity1;
out float lifetime1;
out vec3 flydirection1;

uniform float deltaT;
uniform float totalTime;

void main() {
	age1 = age0[0] + deltaT;

	if(age1 > lifetime0[0]) {
		// Particle dies
		type1 = 1;	
		position1 = position0[0];
		velocity1 = velocity0[0];
		lifetime1 = lifetime0[0];
		flydirection1 = flydirection0[0];
	} else {
		// Particle lives - update position
		type1 = 0;
		position1 = position0[0] + flydirection0[0] * velocity0[0] * deltaT;
		velocity1 = velocity0[0];
		lifetime1 = lifetime0[0];
		flydirection1 = flydirection0[0] + vec3(0,-2.5,0) * deltaT;
	}

	if(type0[0] > 100) {		// Otherwise OpenGL would optimize type away
		EmitVertex();
	}

	EmitVertex();
	EndPrimitive();
}