#version 330 core   

in vec4 Shadow_tex_coord;          //passed on from VS
in vec3 worldNormal;

//uniform sampler2D myTextureSampler;
uniform sampler2DShadow shadowMap;  //shadow map is just a texture

out vec4 fragColor;       //final fragment color

void main(void) {
	//perform perspective division - homogenisierung
	vec3 tex_coords = Shadow_tex_coord.xyz/Shadow_tex_coord.w;

	//read depth value from shadow map
	float inShadow = texture(shadowMap, tex_coords.xyz - vec3(0,0,0.01));
	inShadow = max(min(inShadow, 1.0),0.0);

	fragColor = vec4((worldNormal + 1) / 2 * inShadow, 1.0);
}
