#version 330 core   

layout(location = 0) in vec3 position;     //attribute passsed by the application
layout(location = 1) in vec3 normal;

uniform mat4 modelMatrix;		 //model matrix
uniform mat4 VP;				 // = P_cam * V_cam 
uniform mat4 depthTranslScalVP; // = Mt * Ms * P_light * V_light 
			  
out vec4 Shadow_tex_coord;		 //pass on to the FS
out vec3 worldNormal;

void main(void) {
	//standard trandformation
	gl_Position = VP * modelMatrix * vec4(position, 1.0);  //Output position of the vertex, in clip space
	worldNormal = (modelMatrix * vec4(normal, 0)).xyz;

	//shadow texture coords in projected light space  
	Shadow_tex_coord = depthTranslScalVP * modelMatrix * vec4(position, 1.0);      
} 