#version 330

in vec3 worldNormal;
in vec3 materialColor;
in vec2 tex_uv;
in vec3 N;
in vec3 V;
in vec3 L;

uniform sampler2D colorTexture;

out vec4 fragColor;

void main()
{
	vec3 ambientColor;
	vec3 diffuseColor;
	vec3 specularColor;
	float ambientIntensity;
	float diffuseIntensity;

	vec3 n = normalize(N);
	vec3 v = normalize(V);
	vec3 l = normalize(L);

	float diffuseLambertTerm = dot(l,n);

	//without specular
	vec3 color = texture2D(colorTexture, tex_uv).rgb;
	ambientColor = color;
	diffuseColor = vec3(1.0f, 1.0f, 0.7f);
	ambientIntensity = 0.66f;
	diffuseIntensity = 0.25f;

	fragColor = vec4((ambientColor*ambientIntensity) + (diffuseColor*diffuseLambertTerm*diffuseIntensity), 1.0f);
}


/* CHRIS CODE
#version 330

in vec3 worldNormal;
in vec3 materialColor;
in vec2 tex_uv;
in vec3 N;
in vec3 V;
in vec3 L;

uniform sampler2D colorTexture;

out vec4 fragColor;

void main()
{
	vec3 ambientColor;
	vec3 diffuseColor;
	vec3 specularColor;
	float ambientIntensity;
	float diffuseIntensity;

	vec3 n = normalize(N);
	vec3 v = normalize(V);
	vec3 l = normalize(L);

	float diffuseLambertTerm = dot(l,n);
	if(diffuseLambertTerm < 0) diffuseLambertTerm = 0;
	if(diffuseLambertTerm > 1) diffuseLambertTerm = 1;

	//without specular
	vec3 color = texture2D(colorTexture, tex_uv).rgb;
	ambientColor = color;
	diffuseColor = texture2D(colorTexture, tex_uv).rgb;
	diffuseColor.b *= 0.9;
	ambientIntensity = 0.25f;
	diffuseIntensity = 0.80f;

	fragColor = vec4((ambientColor*ambientIntensity) + (diffuseColor*diffuseLambertTerm*diffuseIntensity), 1.0f);
}
*/