#version 330

in vec3 position;
in vec3 normal;
in vec3 color;
in vec2 uv;

out vec3 worldNormal;
out vec3 materialColor;
out vec2 tex_uv;

uniform mat4 modelMatrix;
uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;
uniform vec3 cameraPosition;

out vec3 N; // normal
out vec3 V; // view vector
out vec3 L; // light vector

void main()
{
	vec3 LightPos = vec3(10.0f, 50.0f, -40.0f);
	N = normalize((modelMatrix * vec4(normal,0.0f)).xyz);
	V = vec3(cameraPosition.x - position.x, cameraPosition.y - position.y, cameraPosition.z - position.z);
	L = vec3(LightPos.x - position.x, LightPos.y - position.y, LightPos.z - position.z);

	gl_Position = projectionMatrix  * viewMatrix * modelMatrix * vec4(position, 1.0);
	worldNormal = (modelMatrix * vec4(normal, 0.0)).xyz; 
	materialColor = color; 
	tex_uv = uv;
}